#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_GiantSharkBomber.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_GiantSharkBomber> Fish_GiantSharkBomber::msSingleton(nullptr);

int Fish_GiantSharkBomber::GetCount()
{
	return (int)mMapData.size();
}

const Fish_GiantSharkBomberData* Fish_GiantSharkBomber::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_GiantSharkBomberData>& Fish_GiantSharkBomber::GetMapData()
{
	return mMapData;
}

void Fish_GiantSharkBomber::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_GiantSharkBomber::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_GiantSharkBomberData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mConsumeEnergy = element->IntAttribute("ConsumeEnergy");
		data.mGoldBombardment = element->IntAttribute("GoldBombardment");
		{
			const char* GoldWeight = element->Attribute("GoldWeight");
			std::vector<std::string> vecGoldWeight;
			boost::split(vecGoldWeight, GoldWeight, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGoldWeight.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGoldWeight[i].c_str(), &temp))
				{
					data.mGoldWeight.push_back(temp);
				}
			}
		}
		{
			const char* GoldFloat = element->Attribute("GoldFloat");
			std::vector<std::string> vecGoldFloat;
			boost::split(vecGoldFloat, GoldFloat, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGoldFloat.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGoldFloat[i].c_str(), &temp))
				{
					data.mGoldFloat.push_back(temp);
				}
			}
		}
		{
			const char* PointWeight = element->Attribute("PointWeight");
			std::vector<std::string> vecPointWeight;
			boost::split(vecPointWeight, PointWeight, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecPointWeight.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecPointWeight[i].c_str(), &temp))
				{
					data.mPointWeight.push_back(temp);
				}
			}
		}
		{
			const char* PointFloat = element->Attribute("PointFloat");
			std::vector<std::string> vecPointFloat;
			boost::split(vecPointFloat, PointFloat, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecPointFloat.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecPointFloat[i].c_str(), &temp))
				{
					data.mPointFloat.push_back(temp);
				}
			}
		}
		{
			const char* GiftPointWeight = element->Attribute("GiftPointWeight");
			std::vector<std::string> vecGiftPointWeight;
			boost::split(vecGiftPointWeight, GiftPointWeight, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGiftPointWeight.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGiftPointWeight[i].c_str(), &temp))
				{
					data.mGiftPointWeight.push_back(temp);
				}
			}
		}
		{
			const char* GiftPointFloat = element->Attribute("GiftPointFloat");
			std::vector<std::string> vecGiftPointFloat;
			boost::split(vecGiftPointFloat, GiftPointFloat, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGiftPointFloat.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGiftPointFloat[i].c_str(), &temp))
				{
					data.mGiftPointFloat.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_GiantSharkBomber::Load()
{
	Load("../Config/Fish_GiantSharkBomber.xml");
}

Fish_GiantSharkBomber* Fish_GiantSharkBomber::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_GiantSharkBomber());
	}
	return msSingleton.get();
}
